# Constants
hwys = ['','1','5', '22', '55', '57', '73', '74', '91', '133', '142', '241', '261', '405', '605']
hwyDirections = ['','NB', 'SB', 'NB/SB','EB','WB','EB/WB']
# Show the login page
def index():
    form = FORM(LABEL('Username:',_for='username', _class="label"),
                INPUT(_name='username',_size='10'),BR(),
                INPUT(_type='submit', _class="submit-button btn btn-primary"))
    if form.process().accepted:
        # Put the username entry into the session variable
        session.username = form.vars.username
        redirect(URL('home'))
    return dict(form=form)
def home():
    return dict(name=session.username)
def help():
    return dict()
# List all the current records in the database - remove in final application
def list():
    highways = db().select(db.closures.ALL, orderby=db.closures.lognum)
    return dict(highways = highways)
# Show details of a single record - remove in final application
def show():
    # Retrieve the requested log entry from the database
    # Assumes the requested entry exists in the db (no error handling yet)
    hwy = db(db.closures.lognum == request.args(0)).select().first()
    return dict(hwy=hwy)
# Display a search form
def search():
    form = FORM(LABEL('ClosureID/Log:',_for='closureid', _class="label"), INPUT(_name='closureid',_size='7'),INPUT(_name='lognum',_size='3'),XML('&nbsp;&nbsp;&nbsp;'), LABEL('Route: ',_for='route', _class="label"), SELECT(hwys,_name='route'), XML('&nbsp;&nbsp;&nbsp;'), LABEL('Direction: ',_for='direction', _class="label"), SELECT(hwyDirections,_name='direction'), BR(),BR(),LABEL('Dates:',_for='startdate', _class="label") ,INPUT(_name='startdate',_class='date'), XML('&nbsp;&nbsp;&nbsp;'), LABEL('  to:',_for='enddate', _class="label"), INPUT(_name='enddate'),'(MMDDYYYY)',BR(),BR(),INPUT(_type='submit', _class="submit-button btn btn-primary"))
    if form.process().accepted:
        # Put the form fields into the session variables
        session.closureid = form.vars.closureid
        session.lognum = form.vars.lognum
        session.startdate = form.vars.startdate
        session.enddate = form.vars.enddate
        session.route = form.vars.route
        session.direction = form.vars.direction
        redirect(URL('results'))
    return dict(form=form)
# Show the item that was found in the search
def results():
    if (len(session.closureid) != 0):
        hwy = db(db.closures.closureid == session.closureid).select() 
        msg = "Closure ID = " + session.closureid
    elif (len(session.route) != 0):
        hwy = db(db.closures.route == session.route).select() 
        msg = "route = " + session.route
    elif (len(session.startdate) == 10):
        hwy = db(db.closures.startdate >= session.startdate).select()
        msg = "Start Date >= " + session.startdate
    else:
        hwy = db().select(db.closures.ALL)
        msg = "ALL"
    count = len(hwy)
    # Show the results in table format.  Get the radio call number from supervisor name lookup
    header = THEAD(TR(TH(''), TH('DTM',BR(),'Area'), TH('Closure ID/',BR(),'Log No.'),TH('Route & Dir/',BR(),'Type of Closure'),TH('Start Date/',BR(),'End Date/',BR(),'Est. Delay'),TH('Facility'),TH('Limits'),TH('Work'), TH('TMP:',BR(),'Cozeep/',BR(),'Detour'),TH('Requestor/',BR(),'Radio Call No.')))
    multiform = []
    for row in hwy:
        statusfields = row.closureid +','+ row.lognum + ',1097,' + str(row.s1097user) +','+ str(row.startdate) + ',' + formatTime(row.starttime) +','+str(row.s1097date)+','+ formatTime(row.s1097time) + ',1098,' + str(row.s1098user) +','+ str(row.s1098date)+','+ formatTime(row.s1098time)+ ',1022,' + str(row.s1022user) +','+ str(row.s1022date)+','+ formatTime(row.s1022time)
        # Each row contains a form with two buttons and columns with fields from database
        multiform.append(TR(TD(
                    XML("<button onclick=showPopup(\'"),statusfields,XML("\')>View History</button>"),BR(),
                    FORM(
                          INPUT(_type='submit',_name='btn2',_value='Show Status Form'),
                          INPUT(_type='hidden',_name='row',_value=row.closureid))),
                          TD(row.closureid[0]),TD(row.closureid,HR(),row.lognum), TD(row.route,' ',row.direction,HR(),row.closuretype), TD(row.startdate,' ',formatTime(row.starttime),HR(),row.enddate,' ',formatTime(row.endtime),HR(),row.estdelay), TD(row.facility),TD(row.startlocation,HR(),row.endlocation), TD(row.worktype), TD(row.tmpcozeep,BR(),row.tmpdetour), TD(row.supervisor,HR(),db(db.supervisors.name == row.supervisor).select().first().radiocallnum) )) 

    session.chosenid = request.vars.row #Pass the hidden field containing the closure ID
    if request.vars.btn2:
        redirect(URL('statuslist'))

    return dict(msg=msg, count=count, highways=hwy, table=header, multiform=multiform)

# Show the status box next to each search result
def statuslist():
    closedItems = []
    if (session.chosenid):
        if (type(session.chosenid) is str):
            retrieved = db(db.closures.closureid == session.chosenid).select().first()
            closedItems.append(retrieved) 
        else:
            # This logic is available to show multiple results, for possible future use.
            for item in session.chosenid:
                retrieved = db(db.closures.closureid == item).select().first()
                closedItems.append(retrieved) 

        form = FORM(BR(), 
                TABLE(THEAD(TR(TH('Closure ID/',BR(),'Log No.'),TH('Route & Dir',BR(),'Type of Closure'),TH('Start Date/',BR(),'End Date/',BR(),'Est. Delay'),TH('Requestor/',BR(),'Radio Call No.'),TH('Status'))),
                    [TR(TD(row.closureid,HR(),row.lognum),TD(row.route,' ',row.direction,HR(),row.closuretype),TD(row.startdate,HR(),row.enddate,HR(),row.estdelay),TD(row.supervisor,BR(),db(db.supervisors.name == row.supervisor).select().first().radiocallnum),TD(LABEL('1097'), INPUT(_type='checkbox', _name='statustype', _value='1097'+row.closureid),LABEL('1098'), INPUT(_type='checkbox', _name='statustype', _value='1098'+row.closureid),LABEL('1022'), INPUT(_type='checkbox', _name='statustype', _value='1022'+row.closureid),BR(), LABEL('Statuser:'),INPUT(_name='statuser',_size='9'))) for row in closedItems],
                    _border='1', _cellpadding='5'),INPUT(_type='submit',_value="submit status form"),)
        
    else:
        msg = "No items were selected.  Use the checkbox in the lefthand column."
        form = ""
        return dict(msg=msg,form=form)
    
    if form.process().accepted:
        #session.flash = 'Status submit acknowledgement appears here.'
        session.statustype = form.vars.statustype
        session.statuser = form.vars.statuser
        redirect(URL('statusAck'))
    return dict(form=form)

# show status update acknowledgement - and update database
def statusAck():
    if (session.statustype):
        if (type(session.statustype) is str):
            msg = "You submitted a status update for " + session.statustype[4:] + ": " + session.statustype[0:4] 
#           Perform the update on the database
            # Construct the name of the field to update 
            fieldname = "s"+session.statustype[0:4]+"user"
            db(db.closures.closureid == session.statustype[4:]).update(**{fieldname:session.statuser})
            import datetime 
            now = datetime.datetime.today()
            fieldname = "s"+session.statustype[0:4]+"date"
            db(db.closures.closureid == session.statustype[4:]).update(**{fieldname:now.strftime("%Y%m%d")})
            fieldname = "s"+session.statustype[0:4]+"time"
            db(db.closures.closureid == session.statustype[4:]).update(**{fieldname:now.strftime("%H%M")})
        else:
            msg = "error because only checking one box is allowed."
    else:
        msg = "Error no statustype checkbox was checked"
        
    return dict(msg=msg)
# Utility functions for formatting
def formatTime(msg):
    if (msg):
        return msg[0:2]+':'+msg[2:4]
    else:
        return ""
# Create a new record
def submit():
    # Don't name this function 'request' because it creates a name conflict with http.request
    hournames = ['','00', '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23']
    closuretypes = ['', 'Lane', 'Full', 'Moving', 'One-Way Traffic', 'Alternating Lanes', 'Traffic Break']
    facilities = ['', 'Connector', 'Conventional_Hwy', 'Mainline', 'Off Ramp', 'On Ramp', 'Rest Area', 'Surface Street']
    worktypes = ['','AC Paving', 'Accident Investigation', 'Attenuator Repair', 'Blasting', 'Bridge Inspection', 'Bridge Work', 'Brush Fire', 'Chip Seal Operation', 'Concrete Pour', 'Core Drilling', 'Crack Seal Operation', 'Curb/Gutter/Sidewalk Work', 'Drainage Cleaning', 'Drainage Inspection', 'Drainage Work', 'Electrical Work', 'Emergency Work', 'Falsework Installation', 'Falsework Removal', 'Fence Work', 'Filming Activity', 'Fog Seal Operation', 'Graffiti Removal', 'Grinding and Paving', 'Grinding Operation', 'Guardrail Repair', 'Guardrail Work', 'Highway Construction', 'K-rail Installation', 'K-rail Removal', 'Landscape Work', 'Litter Removal', 'Maintenance Operation', 'Median Barrier Work', 'Miscellaneous Work', 'Pavement Marker Replacement', 'Pavement Repair', 'Pavement Work', 'Paving Operation', 'Pile Driving', 'Police Investigation', 'Roadway Excavation', 'Roadway Flooding', 'Sewer Work', 'Shoulder Work', 'Sign Work', 'Slab Replacement', 'Slide Removal', 'Slope Clearing', 'Soundwall Work', 'Special Event', 'Spray Operation', 'Striping Operation', 'Survey Work', 'Sweeping Operation', 'Traffic Signal Work', 'Tree Work', 'Utility Work', 'Vegetation Spraying']
    supervisors = ['']  # List of names for the dropdown box
    # Obtain all the supervisor names from the database
    for row in db().select(db.supervisors.ALL):
        supervisors.append(row.name)
    # Build the list of street locations and a hidden cross street lookup table
    streets = ['']
    streetlookup = []
    for row in db().select(db.streets.ALL, orderby=db.streets.street):
        streets.append(row.street)
        streetlookup.append(row.route + ',' + row.street)

    form = FORM(
                LABEL('*Route',_for='route'), SELECT(hwys,_name='route', _id='routecombo', _onchange='routechanged()', requires=IS_LENGTH(minsize=1,error_message='route cannot be empty')), XML('&nbsp;&nbsp;&nbsp;'), 
           LABEL('*Direction',_for='direction'), SELECT(hwyDirections,_name='direction', requires=IS_LENGTH(minsize=1,error_message='direction cannot be empty')), XML('&nbsp;&nbsp;&nbsp;'), 
           LABEL('*Facility',_for='facility'), SELECT(facilities,_name='facility', requires=IS_LENGTH(minsize=1,error_message='facility cannot be empty')), BR(),BR(), 
           TABLE(TR(TD(),TD('*County'),TD('*Location')),TR(TD('BEGIN='),TD(SELECT('ORA',_name='startcounty')),TD(SELECT(streets,_name='startlocation',_id='startlocation')),
           TR(TD('END='),TD(SELECT('ORA',_name='endcounty')),TD(SELECT(streets,_name='endlocation',_id='endlocation'))))),BR(),
           'Date Range:',BR(),
           LABEL('From',_for='startdate'),INPUT(_name='startdate',_size='8',_class='date'), XML('&nbsp;&nbsp;&nbsp;'), 
           LABEL('to:',_for='enddate'), INPUT(_name='enddate',_size='8',_class='date'),'(MMDDYYYY)',XML('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'), 
           LABEL('Times',_for='starttime'),SELECT(hournames,_name='starttime'), 
           LABEL(':',_for='starttimemin'),SELECT('','00','15','30','45','59',_name='starttimemin'), XML('&nbsp;&nbsp;'), 
           LABEL('to:',_for='endtime'),SELECT(hournames,_name='endtime'), 
           LABEL(':',_for='endtimemin'),SELECT('','00','15','30','45','59',_name='endtimemin'), BR(),BR(), 
           TABLE(TR(TD('*Type of Closure'),TD('*Type of Work'),TD('Estimated Delay'),TD('TMP Details')), 
                 TR(TD(SELECT(closuretypes,_name='closuretype',requires=IS_LENGTH(minsize=1,error_message='type of closure cannot be empty'))), 
                    TD(SELECT(worktypes,_name='worktype', requires=IS_LENGTH(minsize=1,error_message='type of work cannot be empty'))), 
                    TD(INPUT(_name='estdelay',_size='4'),'minutes'), 
                    TD(INPUT(_type='checkbox',_name='cozeep'),'CoZeep MaZeep/CHP',BR(), 
                       INPUT(_type='checkbox', _name='detour'),'Detour Available')), 
                 _width='100%' ),
    TABLE(TR(TD('*Supervisor'),TD('Field Rep')), 
                  TR(TD(SELECT(supervisors,_name='supervisor', requires=IS_LENGTH(minsize=1,error_message='supervisor cannot be empty'))),
                     TD(SELECT(supervisors,_name='fieldrep')))),
    TABLE(TR(TD('Meeting Place/CHP Contact'),TD('Reason for Closure'),TD('Additional Remarks / Detour ')), 
                  TR(TD(INPUT(_name='meeting')),TD(INPUT(_name='reason')),TD(INPUT(_name='remarks',_size='40'))) ), BR(), 
            INPUT(_type='submit',_value='Submit Closure'),XML('\n'),SELECT(streetlookup,_name='stlookup', _id='stlookup', _class='hideme')) 
    if form.process().accepted:
        newID = calcNextClosure(form.vars.route)
        # Insert the record into the database
        newrec = db.closures.insert(closureid=newID, lognum='1', route=form.vars.route, direction=form.vars.direction, facility=form.vars.facility, startcounty=form.vars.startcounty, endcounty=form.vars.endcounty, startlocation=form.vars.startlocation, endlocation=form.vars.endlocation, startdate=form.vars.startdate, enddate=form.vars.enddate, starttime=form.vars.starttime+form.vars.starttimemin, endtime=form.vars.endtime+form.vars.endtimemin, closuretype=form.vars.closuretype, worktype=form.vars.worktype, estdelay=form.vars.estdelay, tmpcozeep=getCheckbox(form.vars.cozeep), tmpdetour=getCheckbox(form.vars.detour), supervisor=form.vars.supervisor, fieldrep=form.vars.fieldrep,  )
        session.flash = 'New lane closure added: ' + newID
        redirect(URL('index.html'))
    return dict(form=form)

# Calculate the closure id to assign to the new closure
def calcNextClosure(routeNum):
    # Retrieve any existing closures on this route
    item = db(db.closures.closureid.startswith('T'+routeNum)).select().last() # Might need to sort these
    if (item != None):
        currID = item.closureid
        lastchar = currID[-1:]  # Get last character of ID
        lastchar = chr(ord(lastchar) + 1) # increment it to next character (need bounds check)
        newID = currID[:-1] + lastchar  # append char to ID
        return newID
    else:
        return 'T'+routeNum+'AA'  # For a non-existing route

# Convert checkbox value to YES/NO
def getCheckbox(ckBox):
    if (ckBox == "on"):
        return "YES"
    else:
        return "NO"
